Unit SF46R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF12_p, SF35R_p;

function SF46R(X :Real; N :Integer; var IERR :Integer): Real;

implementation

function SF46R(X :Real; N :Integer; var IERR :Integer): Real;
var
IE :Integer;
A,Y,S,DSQA,XD,Z,E,C,ARG :Real;
const
SYS059 :Real = 3.4E38;
SMALL :Real = 174.0E0;
SMALL1 :Real = 13.3E0;
CONE :Real = 0.5723649E0;
SYS034 :Real = 0.56418958354775628694807945156077;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
{ Result -    SF46R  FORTRANe }
if ( X >= 0.0 ) 
 then goto _1;
IERR := 65;
goto _10;
_1:
if ( N >= 1 ) 
 then goto _2;
IERR := 66;
goto _10;
_2:
A := 0.5*X;
IERR := 0;
Y := 0.0;
IE := 0;
if ( N = (N div 2)*2 ) 
 then IE := 1;
if ( ((IE = 1) ) or ( (N > 2)) ) and ( (A <= SMALL) ) 
 then Y := Exp(-A);
S := Y;
if ( IE <> 0 ) 
 then goto _3;
DSQA := Sqrt(A);
S := 0.0;
if ( DSQA < SMALL1 ) 
 then S := SF35R(DSQA);
_3:
if ( N > 2 ) 
 then goto _5;
_4:
Result := S;
goto _11;
_5:
XD := 0.5*(N-1);
Z := 1.0;
if ( IE = 0 ) 
 then Z := 0.5;
if ( A <= SMALL ) 
 then goto _7;
E := 0.0;
if ( IE = 0 ) 
 then E := CONE;
C := Ln(A);
_6:
if ( Z > XD ) 
 then goto _4;
E := Ln(Z)+E;
ARG := C*Z-A-E;
if ( ARG >= (-SMALL) ) 
 then S := Exp(ARG)+S;
Z := Z+1.0;
goto _6;
_7:
E := 1.0;
C := 0.0;
if ( A = 0.0 ) 
 then goto _9;
if ( IE = 0 ) 
 then E := SYS034/DSQA;
_8:
E := E*A/Z;
if ( C = C+E ) 
 then goto _9;
C := C+E;
Z := Z+1.0;
if ( Z <= XD ) 
 then goto _8;
_9:
Result := C*Y+S;
goto _11;
_10:
UTSF12(IERR,46);
Result := SYS059;
_11:
exit;
end;

end.
